/***************************************************************************/
/*                                                                         */
/* Datei-Name      : GETRTC.C                                              */
/* Project         : GETRTC                                                */
/* sonst. Module   : ---                                                   */
/* Compiler        : BC 3.1                                                */
/* Betriebs-System : MS-DOSE                                               */
/* Autor           : J. Kuenstner                                          */
/* Datum           : Jan.  95                                              */
/* Beschreibung    :                                                       */
/*                                                                         */
/*      Entstand aus dem Artikel: "Stechuhr" in c't 11/94 auf Seite 248    */
/*      Hintergrund-Informationen zum RTC-Chip in c't 12/88 auf Seite 196  */
/*      Zugriff auf die Register im RTC erfolgt folgendermassen:           */
/*      Schreiben der Regsister-Nummer auf Port 0x70                       */
/*      Lesen oder Schreiben des gewnschten Registers auf Port 0x71       */
/*                                                                         */
/*        RTC-Register                                                     */
/*       Ŀ                                       */
/*        0:  Sekunde                                                   */
/*        1:  Alarm-Sekunde                                             */
/*        2:  Minute                                                    */
/*        3:  Alarm-Minute                                              */
/*        4:  Stunde                                                    */
/*        5:  Alarm-Stunde                                              */
/*        6:  Wochentag                                                 */
/*        7:  Tag                                                       */
/*        8:  Monat                                                     */
/*        9:  Jahr                                                      */
/*       10:  StatusRegister A                                          */
/*       11:  StatusRegister B                                          */
/*       12:  StatusRegister C                                          */
/*       13:  StatusRegister D                                          */
/*                                              */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/***************************************************************************/
/*                               HISTORY                                   */
/*                                                                         */
/* Datum     | wer         | was                                           */
/* ------------------------------------------------------------------------*/
/*           |             |                                               */
/* 28.01.95  | Jogi        | Erst-Implementierung                          */
/* ------------------------------------------------------------------------*/
/* 02.06.95  | Jogi        | Kopf reinkopiert und only_once_a_day defined  */
/* ------------------------------------------------------------------------*/
/* 08.02.97  | Jogi        | Excel-File (kein Text, durch TABS getrennt)   */
/* ------------------------------------------------------------------------*/
/* 28.02.98  | Jogi        | mail-Adresse in Hilfe weil ich das Dingens    */
/*           |             | auf meine Home-Page lege                      */
/*           |             |                                               */
/*                                                                         */
/***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __TURBOC__
	#include <dir.h> 
#else
 struct ftime {
        unsigned ft_tsec  : 5;  /* Sekunden */
        unsigned ft_min   : 6;  /* Minuten */
        unsigned ft_hour  : 5;  /* Stunden */
        unsigned ft_day   : 5;  /* Tage */
        unsigned ft_month : 4;  /* Monate */
        unsigned ft_year  : 7;  /* Jahr - 1980 */
 };
#define outportb(x,y) outp((x),(y))
#define inportb(x) 	inp(x) 
#endif
#include <dos.h>
#include <io.h>
#include <conio.h>
#include <time.h>

#define LOGFILENAME "LOGIN.TXT"
#define LOGEXCELNAME "LOGIN.XLS"



#define UPDATE_MASK 		0x80				/* MSB in Register A: Update in Progress */


#define RTC_CHOICE		0x70				/*  Auswahl was gelesen werden soll */
#define RTC_REG			0x71				/*  das eigentliche Schreib-Lese-Register */

#define SEK					0
#define AL_SEK				1
#define MIN					2
#define AL_MIN				3
#define HOUR				4
#define AL_HOUR			5
#define DAY					7
#define STATUS_A			10




typedef unsigned char byte;					/* wir basteln uns ein Byte */
typedef unsigned int  word;					/* wir basteln uns ein Word */
typedef struct { unsigned zeit; unsigned datum;} DateTime;

const char szVersion[]="1.1";

char wotage[7][3] = { "So","Mo","Di","Mi","Do","Fr","Sa" };




static char ucPathAndProgram[256];

static char ucExeDrive[_MAX_DRIVE];
static char ucExeDirectory[_MAX_DIR];
static char ucExeFileName[_MAX_FNAME];
static char ucExeExtension[_MAX_EXT];



#ifdef SO_SEHEN_DIE_STRUCTS_AUS
----------------------------------------------------------------------------

 struct ftime {
        unsigned ft_tsec  : 5;  /* Sekunden */
        unsigned ft_min   : 6;  /* Minuten */
        unsigned ft_hour  : 5;  /* Stunden */
        unsigned ft_day   : 5;  /* Tage */
        unsigned ft_month : 4;  /* Monate */
        unsigned ft_year  : 7;  /* Jahr - 1980 */
 };


  ft_hour     ft_min    ft_tsec
 15.....11 10........5 4.......0
͹
ͼ
  Stunden   Minuten   Sekunden/2

	 ft_year   ft_month   ft_day
 31.........25 24...21 20.....16
͹
ͼ
 Jahr - 1980    Monat     Tag

----------------------------------------------------------------------------

struct find_t {
  char     reserved[21];   /* fuer Microsoft reserviert - nicht aendern */
  char     attrib;         /* Attribut-Byte fuer entsprechende Datei */
  unsigned wr_time;        /* Zeit des letzten Schreibvorgangs  */
  unsigned wr_date;        /* Datum des letzten Schreibvorgangs */
  long     size;           /* Dateigroessee   */
  char     name[13];       /* ASCII-Name der uebereinstimmenden Datei */
};

----------------------------------------------------------------------------

struct tm {
  int tm_sec;      /* Sekunden */
  int tm_min;      /* Minuten */
  int tm_hour;     /* Stunde 0--23) */
  int tm_mday;     /* Monatstag    (1--31) */
  int tm_mon;      /* Monat (0--11) */
  int tm_year;     /* Jahr (Kalenderjahr minus 1900) */
  int tm_wday;     /* Wochentag (0--6; Sonntag = 0) */
  int tm_yday;     /* Jahrestag (0--365) */
  int tm_isdst;    /* 0, wenn Sommerzeit deaktiviert ist) */
};

----------------------------------------------------------------------------

#endif

static int bcd2int( int bcd );
static int TestHelp( int nCount, char **ppchVect );
static int PrintAufruf( int help );

int main(int argc, char *argv[])
{
	FILE *fp;

	int min,hour,mon,day;
	int Amon,Aday,Amin,Ahour;
	int test;
	int i;

	char pszLogFileName[255];

	int only_once_a_day;
	int bExcelFormat;

	time_t heutesek;						/* Zeit seit 1.1.70 in sek fuer aktuelle Zeit */
	struct tm *hs;							/* aktuelle Zeit als Struktur                 */


	struct find_t Datei;
	union {									/* was dazu wohl der R.B. sagen wuerde ? */
		DateTime File;
		struct ftime Info;
	}FI;
	unsigned int schlecht;

	strcpy(ucPathAndProgram,argv[0]);
	_splitpath(ucPathAndProgram,ucExeDrive,ucExeDirectory,ucExeFileName,ucExeExtension);

	if(TestHelp(argc,argv))
	{
		PrintAufruf(1);
		exit(1);
	}

	only_once_a_day = 0;
	bExcelFormat = 0;
	for(i= 1; i < argc ; ++ i)
	{
		if(strcmp(strupr(argv[i]),"-O") == 0 )
		{
			only_once_a_day = 1;
		}
		if(strcmp(strupr(argv[i]),"-E") == 0 )
		{
			bExcelFormat = 1;
		}

	}


/* Speichern von aktuellem Pfad ... */

	if(bExcelFormat)
	{
		sprintf( pszLogFileName,"%s%s%s",ucExeDrive,ucExeDirectory,LOGEXCELNAME);
	}
	else
	{
		sprintf(pszLogFileName,"%s%s%s",ucExeDrive,ucExeDirectory,LOGFILENAME);
	}
/*----------------------------------------------------------------------
		  Holen der Aktuellen System-Zeit und umwandeln in struct tm                              */

	(void)time( &heutesek );
	hs = localtime( &heutesek );

	if( only_once_a_day )
	{

/*----------------------------------------------------------------------
	Holen der File-Zeit des LOG-Files und pressen in eine struct                                                                                            */

		schlecht = _dos_findfirst( pszLogFileName, _A_NORMAL, &Datei );

		FI.File.datum = Datei.wr_date;		/* der ist hart, Bitgeschiebe,      */
														/* aber es macht ja der Compiler    */
		if(!schlecht)								/* schlecht = 0; => Datei vorhanden */
		{

			if( hs->tm_mday == (int) FI.Info.ft_day) 	/* Aktueller Tag = File-Tag */
			{
				if(( hs->tm_mon + 1) == (int) FI.Info.ft_month)		/* Aktueller Month = File-Month */
				{
					/* printf("War schon dran\n"); */
					return 1;
				}
			}
		}
	}
	do
	{
		_disable();											/* Interrupt sperren */
		outportb( RTC_CHOICE, STATUS_A );			/* Zugriff auf Register A */
		test = (byte) (inportb( RTC_REG ) & UPDATE_MASK );
		if(!test)
		{                                            /* wenn Bit 7 = 0 dann Gut */
			_disable();
			outportb( RTC_CHOICE, AL_SEK );				/* Zugriff auf Alarm-Sekunden 	*/
																	/* diese werden fuer Alarm-Tag	*/
																	/* missbraucht */
			Aday = bcd2int( inportb( RTC_REG ));		/* und einlesen	*/

			outportb( RTC_CHOICE, AL_MIN );				/* Zugriff auf Alarm-Minuten, */
			Amin = bcd2int( inportb( RTC_REG ));		/* und einlesen	*/

			outportb( RTC_CHOICE, AL_HOUR );				/* Zugriff auf Alarm-Stunde */
			Ahour = bcd2int( inportb( RTC_REG ));		/* und einlesen */
			_enable();
		}
	}
	while( test );
	fp = fopen( pszLogFileName, "a" );
	if(fp == NULL)
	{
		fprintf( stderr, "Sorry, kann Datei %s nicht oeffnen\n", pszLogFileName );
	}
	else
	{
		mon  = hs->tm_mon+1;
		day  = hs->tm_mday;
		hour = hs->tm_hour;
		min  = hs->tm_min;
		Amon = mon;												/* Alarm-Monat = Monat */
		if( Aday > day )											/* aber wenn Monats-Umbruch */
		{
			Amon = mon - 1;									/* dann eben - 1 */
			if( Amon == 0 )									/* falls Januar */
			{
				Amon = 12;										/* dann eben Dezember */
			}
		}
		if( bExcelFormat )
		{
			fprintf( fp, "\t%2d:%02d\n", Ahour, Amin );
			fprintf( fp, "%02d.%02d.%04d\t%2d:%02d", day, mon, hs->tm_year + 1900, hour, min );
		}
		else
		{
			fprintf( fp, "Aus am    %02d.%02d      : %2d:%02d Uhr\n\n", Aday, Amon, Ahour, Amin );
			fprintf( fp, "Ein am %s %02d.%02d.%04d : %2d:%02d Uhr\n", wotage[hs->tm_wday], day, mon, hs->tm_year + 1900,hour, min);
		}
		fclose( fp );
	}
	return 0;
}


static int bcd2int( int bcd )
{
	return (int) (( ((bcd >> 4) & 0xF ) * 10 ) + ( bcd & 0xF ));
}


/***************************************************************************/
/*  Name:                                                                  */
/*        TestHelp                                                         */
/*  Beschreibung:                                                          */
/*                                                                         */
/*  Funktion ueberprueft, ob in der Kommando-Zeile Hilfe                   */
/*  ueber /h /H /? angefordert wurde.                                      */
/*  Uebergabe-Parameter: int nCount: entspricht argc aus main              */
/*                      char *ppchVect: entspricht argv aus mai            */
/*                                                                         */
/*  Rueckgabe: 1 falls Hilfe angefordert wurde                             */
/*            0 falls keine Hilfe angefordert wurde                        */
/*                                                                         */
/***************************************************************************/


static int TestHelp( int nCount, char **ppchVect )
{
	int i;

	for( i=0 ; i < nCount ; ++i )			/* ueber alle Cmd-Line-Arg */
	{
		if((ppchVect[i][0] == '/') ||
			(ppchVect[i][0] == '-'))	/* richtiger Trenner ?? */
		{
			if((ppchVect[i][1] == '?') ||
				(ppchVect[i][1] == 'h') ||
				(ppchVect[i][1] == 'H') )
			{
				return 1;  /* /? /h /H = Hilfe geben */
			}
		}
	}
	return 0;
}



static int PrintAufruf( int help )
{
	printf("%s Ver %s (c) Jogi 1995-98\n",ucExeFileName, szVersion );
	if(help)
	{
		printf( "Dieses Programm liest die Alarm-Zeit aus der batteriegepufferten Uhr aus und\n");
		printf( "schreibt diese und die aktuelle Zeit in ein File mit dem Namen %s \n",LOGFILENAME);
		printf( "im selben Verzeichnis wie das EXE-File.\n");
		printf( "Das Gegenstueck PUTRTC.COM ist ein TSR, das alle 10 Sek. die aktuelle Zeit\n");
		printf( "in den Alarm-Registern der Echtzeituhr hinterlegt.\n");
		printf( "Dadurch kann man die Ausschaltzeit eines Rechners mitprotokollieren.\n");
		printf( "Sinnigerweise plaziert man beide Programme in der AUTOEXEC.BAT .\n");
		printf( "Zuerst muss man das Programm %s aufrufen, um die letzte Auschaltzeit\n",ucExeFileName);
		printf( "zu erhalten, anschliessend kann man das Programm PUTRTC aufrufen.\n");
		printf( "\nAufruf:    %8s [-h] [-?] [-o][-e]\n",ucExeFileName);
		printf( "\n");
		printf( "Optionen:\n");
		printf( "  -h-?: gibt diese Hilfe aus\n");
		printf( "  -o  : steht fuer OnlyOnceADay, das bedeutet es wird nur \n");
		printf( "        das erste Einschalten am Tag mitprotokolliert\n");
		printf( "  -e  : es wird im EXCEL-Format (kein Text, TABS ) abgespeichert und die \n");
		printf( "        Log-Datei erhaelt den Namen %s\n",LOGEXCELNAME);
		printf( "\n");
		printf( "Kommentare, Probleme, ... an:  jogi@compuserve.com\n");
		printf( "Homepage: http://ourworld.compuserve.com/homepages/jogi\n");

	}
	return 0;
}

